Changes in version: SGP_1.5-0.0

  USER VISIBLE CHANGES:

	  o Analyses now export output to txt file contained in Log directory.
	  o Growth and Achievement Plots now support individual student reports and arbitrary grade level starting points.
	  o testSGP automatically detects YEAR in SGPdata so annual updates are no longer necessary for tests.

Changes in version: SGP_1.4-0.0

  USER VISIBLE CHANGES:

	  o Package accomdates assessment transitions with equating from old to new test and provides robust diagnostics associated with equating.
	  o Adding ability to generate student reports for examining showing two different tests.
	  o Goodness of fit plots now provide diagnostic information on floor and ceiling effects.
	  o SGP package now calculates time dependent student growth percentiles/projections (SGPt).
	  o Numerous performance improvements (speed and memory use)!

Changes in version: SGP_1.3-0.0

  USER VISIBLE CHANGES:

	  o Adding internal getJSON function to studentGrowthPlot_Styles to export student level JSON suitable to interactive student reports.
	  o Added Illinois meta-data to SGPstateData.
	  o Adding cuts to projection fan.
	  o Bumped YEAR up 1.
	  o analyzeSGP now accepts argument sgp.sqlite - if set to TRUE function will output a temporary SQLite file of essential data from SGP object's @Data slot and use SQLite queries to pull data subsets used in lower-level functions.  This option entails some time overhead for read/write to/from disk, but ultimately provides substantial RAM memory saving during computation (particularly parallel computation).  Default is NULL, in which case @Data slots larger than 1 GB are written to disk (set internally to TRUE).
	  o Simulation data in .simex.sgp routine of studentGrowthPercentiles is now saved to .sqlite databases as a RAM memory saving measure.
	  o Results and simulation data used in summarizeSGP to produce summary tables are now exported to temporary a .sqlite file, and utility functions have been externalized.  This provides memory savings, particularly for Windows users.
	  o PNG versions of bubblePlots can now be produced through visualizeSGP using the bPlot.output argument.

Changes in version: SGP_1.2-0.0

  USER VISIBLE CHANGES:

	  o Removed LICENSE and changed copyright to GPL-2.
	  o Added capability to calculate student growth projections for End of Course testing sequences.
	  o Added capability to calculate scale score targets to combineSGP and visualize them on student growth plots.
	  o Added capability to calculate weighted medians and weighted means in summarizeSGP.
	  o Added Guatemala meta-data to SGPstateData. 
	  o Added argument 'steps' to updateSGP allowing user to specify steps that abcSGP uses as part of updateSGP. 
	  o Added MS baseline coefficient matrices to SGPstateData. 
	  o Corrected error message provided in summarizeSGP for INSTRUCTOR_NUMBER summaries. 
	  o outputSGP output.type='SchoolView' now outputs JSON data for tables. 
	  o Added argument return.norm.group.scale.scores to studentGrowthPercentiles to return score vector of each student associated with their SGP. 
	  o Changed growth trajectory to distinguishing color on growth achievement plots.
	  o Added argument sgp.cohort.size to studentGrowthPercentiles to control minimum cohort size restriction.
	  o summarizeSGP now calculates bootstrap standard errors as well as bootstrap confidence intervals.
	  o outputSGP now includes ability to export data for FINAL YEAR of long format 'LONG_FINAL_YEAR_Data'.
	  o combineSGP now produces current year targets as well as lagged targets adding arguments 'sgp.projections' and 'sgp.projections.baseline'.
	  o student growth plot now functions with end of course tests. See testSGP(4) for an implemented example.

Changes in version: SGP_1.1-0.0

  USER VISIBLE CHANGES:

	  o Updated Thanks in DESCRIPTION 

Changes in version: SGP_1.0-9.9

  BUG FIXES:

	  o growthAchievementPlot now renders baseline referenced SGP correctly.

Changes in version: SGP_1.0-9.8

  USER VISIBLE CHANGES:

	  o Updated CSEM calculation algorithm and refined code in analyzeSGP to calculate CSEMs for both cohort and baseline referenced SGPs

Changes in version: SGP_1.0-9.7

  USER VISIBLE CHANGES:

	  o Changed examples to work with 2012_2013 year of new SGPdata.

Changes in version: SGP_1.0-9.6

  USER VISIBLE CHANGES:

	  o Update variable names for Hawaii state data

Changes in version: SGP_1.0-9.5

  BUG FIXES:

	  o studentGrowthPercentiles now correctly adjusts length of content.area.progression (when supplied) when num.prior also used.

Changes in version: SGP_1.0-9.4

  USER VISIBLE CHANGES:

	  o Updated package SGPdata separating INSTRUCTOR_NUMBER from sgpData_LONG and creating sgpData_INSTRUCTOR_NUMBER as a prototype multiple membership table.
	  o Removed INSTRUCTOR_NUMBER variables names from the variable name lookup for DEMO.
	  o Altered the way the package deals with 'multiple.membership.groups'. New slot @Data_Supplemental includes multiple membership supplemental tables (like sgpData_INSTRUCTOR_NUMBER).

Changes in version: SGP_1.0-9.3

  USER VISIBLE CHANGES:

	  o Added use.my.coefficient.matrices argument to abcSGP to faciliate updateSGP.
	  o updateSGP now allows for single argument of 'what_sgp_object' to be supplied allowing for re-calculation of SGPs using embedded coefficient matrices.

Changes in version: SGP_1.0-9.2

  USER VISIBLE CHANGES:

	  o Added prior achievement content area to goodness of fit charts showing growth by prior achievement.
	  o Added two more Economics repeat sequences to baseline matrices for Georgia.

Changes in version: SGP_1.0-9.1

	  o Completed embedding of GA baseline matrices into SGPstateData.


  USER VISIBLE CHANGES:

	  o Integrated YEAR_WITHIN into getPanelData.
	  o Integrated SGP_Norm_Group_Preference into combineSGP for states with multiple end of course assessments.
	  o Integrated ME baseline coefficient matrices into SGPstateData.

  BUG FIXES:

	  o Various minor bug fixes and refinements.


Changes in version: SGP_1.0-8.0

  USER VISIBLE CHANGES:

	  o Added YEAR_WITHIN capability to package to better accomodate interim assessment.

  NEW FEATURES:

	  o Added YEAR_WITHIN capability to package to better accomodate interim assessment.

Changes in version: SGP_1.0-7.0

  USER VISIBLE CHANGES:

	  o Added Professor Yi Shang as author of package.

  NEW FEATURES:

	  o Final integration of SIMEX measurement error correction into studentGrowthPercentiles.

  BUG FIXES:

	  o Fixed bug in as.splineMatrix that was applied to old object of class SGP.

Changes in version: SGP_1.0-6.0

  NEW FEATURES:

	  o Initial integration of SIMEX measurement error correction into studentGrowthPercentiles.


Changes in version: SGP_1.0-5.0

  NEW FEATURES:

	  o Integrate ability to specify preferred SGP using SGPstateData and internal function getPreferredSGP. See GA SGPstateData for an example.

  USER VISIBLE CHANGES:

	  o Modified two physical science baseline coefficient matrices to EOCT from grade 8.
	  o Output messages for studentGrowthPercentiles and studentGrowthProjections indicate number of students utilized for the analyses.


Changes in version: SGP_1.0-4.0

  NEW FEATURES:

	  o summarizeSGP now provides the standard deviation of the SCALE_SCORE_PRIOR_STANDARDIZED for each group indicating a level of incoming student homogeneity/heterogeneity.

  BUG FIXES:

	  o Fixed bug associated with creation of enhanced goodness of fit plots.


Changes in version: SGP_1.0-3.0

  USER VISIBLE CHANGES:

	  o Deprecated use of MULTICORE, MPI, and REDIS in favor of PARALLEL.
	  o Exported previously internal function createKnotsBoundaries allowing for users to generated Knots, Boundaries, Loss/Hoss values separately.
	  o studentGrowthPercentiles includes new argument for 'return.prior.scale.score.standardize' that generates the variable 'SCALE_SCORE_PRIOR_STANDARDIZED'.
	  o growthAchievementPlot includes new argument for 'output.format' that allows for both 'PDF' and 'PNG' output.
	  o Previous growthAchievementPlot argument 'pdf.folder' changed to 'output.folder'.
	  o analyzeSGP prints goodness of fit plots in two formats: 'PDF' and 'PNG'.
	  o Added Australia/NAPLAN data to SGPstateData.
	  o Updated CITATION.

Changes in version: SGP_1.0-0.0

  NEW FEATURES:

	  o Update goodness of fit plots to include an additional representation of growth percentiles by prior achievement level.
	  o Incorporated updateSGP into SGP package including a new test in testSGP, testSGP(2), utilizing it.

  USER VISIBLE CHANGES:

	  o Removed parallel functionality for deprecated SNOW and MULTICORE packages, as well as FOREACH implementations of doMC, doMPI, doSNOW and doRedis.
	  o Removed chunk.size argument from 'studentGrowthProjections' function based upon refined implementation using data.table.
	  o Changed SGP_LEVEL and SGP_LEVEL_BASELINE to ordered factor from factor.
	  o SGPstateData is now an environment instead of a list so that updates can be smoothly added.

Changes in version: SGP_0.9-9.9

  NEW FEATURES:

	  o Update of splineMatrix class to include a validity check and update of as.splineMatrix to convert older splineMatrices to current version.

Changes in version: SGP_0.9-9.8

  NEW FEATURES:

	  o Major re-factoring of package involving externalization of previously internal functions for better unit testing.



Changes in version: SGP_0.9-9.7

  NEW FEATURES:

	  o studentGrowthPlot allows arrow.legend.color to be specified in a state specific fashion and controlled from SGPstateData.
	  o checkSGP converts ID to numeric to take advantage of data.table improvements.
	  o checkSGP checks for match between levels in ACHIEVEMENT_LEVEL and SGPstateData.
	  o Added organization abbreviation to SGPstateData.
	  o Added Move Up Calculations to combineSGP.
	  o Made major refinements to growthAchievementPlot and visualizeSGP that speeds up the creation of growth and achievement plots.
	  o Improved baselineSGP configuration for dealing with non-standard content area progressions.
	  o On *NIX OS types studentGrowthPlot directories are zipped/gzipped and directory removed to minimize space requirements.
	  o outputSGP converts names back to @Names$name.original.
	  o Projection fan in student growth plots now projects across multiple year spans.
	  o Internal capwords function now exported and available for use.
	  o Added argument sgPlot.zip to visualizeSGP and studentGrowthPlot_Styles to control zip compression of school studentGrowthPlot folders.
	  o Added shrinkage estimator calculation to summarizeSGP.
	  o Added PNG and PDF_PIECES output of student growth plots via the visualizeSGP option sgPlot.output.format='PNG' or sgPlot.output.format='PDF_PIECES'.
	  o splineMatrix class now includes slots for 'Content_Areas' and 'Grade_Progresssion' to accomodate more varied prior score combinations.
	  o Added argument 'content.area.progression' to studentGrowthPercentiles to accomodate non-uniform content area progressions as priors to be included in the coefficient matrices produced/used.
	  o Integrated sgp.loss.hoss.adjustment into analyzeSGP.
	  o Added STAY_UP as part of previous MOVE_UP analyses. combineSGP now calculates CATCH_UP/KEEP_UP/MOVE_UP/STAY_UP.
	  o Added additional functionality to 'studentGrowthPlot_Styles' allowing for the construction of student growth plot catalogs by instructor.
	  o Refinements of merges in 'combineSGP' to maximize speed and efficiency.
	  o Created internal function 'getStateAbbreviation' to handle calculation of state abbreviation with SGP functions based upon supplied sgp_object argument name.
	  o Added gofSGP function to create more thorough goodness-of-fit plots including results distributed by prior achievement level.
	  o Added Indiana baseline coefficient matrices to SGPstateData.

  USER VISIBLE CHANGES:

	  o Updated Hawaii variable name lookup table.
	  o Zipped files for studentGrowthPlots and outputSGP no longer include full file path. 
	  o Internal capwords function now exported and available for use.
	  o Removed parentheses in naming of folders when sgPlot.folder.names='name' is supplied.
	  o Instructor by School Number tables now include EMH_LEVEL aggregations as well.

  BUG FIXES:

	  o Fixed spacing bug for attaching front page to studentGrowthPlots.
	  o Corrected logic bug in combineSGP leading to the creation of SGP_TARGET when no projections exist.
	  o Projection fan cuts calculated across a gap year using a piecewise transformation corrected to accomodate corect increase in years.
	  o studentGrowthPercentiles and studentGrowthProjections better checks for empty data.
	  o Corrected naming of baseline coefficient matrices for New Jersey.


Changes in version: SGP_0.9-9.0

  NEW FEATURES:

  USER VISIBLE CHANGES:

	  o Updated URLs in package to github site that hosts SGP code development.
	  o Added timing to outputSGP and sqliteSGP and integrated outputSGP into abcSGP.
	  o Baseline SGP tables embedded in SGP object have variable names appended with '_BASELINE'.
	  o Streamlined growthAchievementPlot production by removing growthAchievementPlot_Styles and integrating its functionality elsewhere.
	  o outputSGP now exports contents of @Data by default to 'Data' directory.
	  o Updated SGPstateData with Georgia variable name lookup table.
	  o studentGrowthPercentiles deals better with holes in data structures where certain grade progressions yield empty data sets.
	  o baselineSGP analyses from analyzeSGP now accept arguments supplied to content_areas, years, and grades if one wants to filter those for baseline SGP analyses or coefficient matrix generation.
	  o summarizeSGP does not produces by default, all possible summary tables (controlled by the arugment 'produce.all.summary.tables'). A subset of about 70 summary tables are produced.
	  o Added baseline coefficient matrices for Georgia to SGPstateData.
	  o Fixed prepareSGP to better update @Names slot.
	  o Added Archdiocese of Baltimore to SGPstateData.
	  o Integrated achievement_level_recode function into prepareSGP.
	  o Added ability to print studentGrowthPlots for one, four and five content areas.
	  o Added timing output to outputSGP LONG file production.
	  o If grade.progression supplied to studentGrowthPercentiles exceeds number of panels available, function now uses the tail of the grade progression up to the number of panels supplied.
	  o Added 'WIDE_Data' output.type to outputSGP.
	  o Added variable name lookup table for Maine.
	  o Updated summarizeSGP to create relevant tables based upon state provided institution levels.
	  o Added 'use.cohort.for.baseline.when.missing' argument to combineSGP that allows for the use of cohort reference SGPs in place of baseline referenced SGPs when no baseline SGPs exist.
	  o Added Variable_Name_Lookup for New Jersey to SGPstateData.
	  o Updated list of contributors.
	  o Added testSGP function to package to faciliate development and testing of package. 
	  o Added argument 'create.additional.variables' to prepareSGP indicating whether additional variables should be added to @Data (defaults to TRUE). 
	  o prepareSGP now adds variable HIGH_NEED_STATUS to @Data by default indicating students in top and bottom quartile by school, grade, content area and year.
	  o Changed naming convention between from TESTING_YEAR to CURRENT to apply to all states going forward.
	  o Tidied up title for goodness of fit plots and modified plots to deal with edge cases where there are not 10 prior score deciles.
	  o Added variable name lookup for Massachusetts.
	  o Refined summarizeSGP to better detect ENROLLMENT_STATUS variable in supplied @Data.
	  o Added argument 'sgp.loss.hoss.adjustment' to studentGrowthPercentiles to adjust SGP calculation for hoss values where ceiling effect impacts SGP calculation.
	  o Updated loss/hoss values for Hawaii based upon apparent scale change in 2011.
	  o Modified .year.increment in studentGrowthPercentiles to accomodate baseline SGP analyses.
	  o Added Washington data to SGPstateData including basseline coefficient matrices.
	  o growthAchievementPlot not accomodates gaps in years tested if coefficient matrices are available across that gap.
	  o Updated Idaho knots and boundaries to accomodate 2011 scale scores.
	  o Added West Virginia variable name lookup table.
	  o Changed implementation of VALID_CASE to character from factor to better coincide with data.table 1.8.2 requirements.
	  o Added argument return.prior.scale.score to studentGrowthPercentiles to incorporate the return of the prior scale score for the student.
          o studentGrowthPercentiles now accomodates multiple priors from the same year. See examples in 'analyzeSGP' details.
          o Updated Kansas metadata in SGPstateData.
          o Fixed bug in get.panel.data and get.panel.data.vnames that didn't accomodate missing grades in state testing programs correctly.
          o Added function (internal) checkSGP to externalize checks on SGP object confirming it is up to date.
          o Added Colorado variable name lookup table to SGPstateData.
          o Changed default of outputSGP to export LONG and WIDE data.
          o Added CO baseline matrices based upon 5 years of panel data from 2005 to 2009.


  BUG FIXES:

	  o Added PERCENT_CATCHING_UP_KEEPING_UP to summarizeSGP if SGP_TARGET is present.
	  o Corrected issues with conversion of factors to characters in summarizeSGP.
	  o Corrected names.type error in RI and NH lookup tables.
	  o Corrected incorrect timing in visualizeSGP due to over writing time.started in function.
	  o Rewrote merge in combineSGP that adds data to @Data.
	  o Made correction to cutscore year lookup code in growthAchievementPlot and prepareSGP.
	  o studentGrowthPercentiles checks for CSEMs and ensures availability by content area.
	  o Fixed bug in way state name is detected in argument supplied as part of data name.
	  o Removed redundant years, content_areas specification in abcSGP.
	  o analyzeSGP not checks for content area specific coefficient matrices and only calculates baseline referenced results for those content areas.
	  o Supplied panel.data.vnames now subsets only those names in supplied panel data.
	  o Refined of merge of sgp targets in combineSGP to avoid memory copy of sgp_object.
	  o studentGrowthPlot function now detects year dependent loss/hoss values.
	  o summarizeSGP now checks for existence of ACHIEVEMENT_LEVEL_PRIOR before attempting to calculate it.
	  o summarizeSGP better checks for inclusion variables.
	  o Corrected various bugs in bubblePlot Style 100 introduced with @Names data.frame.
	  o Modified analyzeSGP to work with data.table changes in 1.8.2.


Changes in version: SGP_0.9-0.0

  NEW FEATURES:

  o Added Hawaii data to SGPstateData and updated Nevada transitional cutscores in Mathematics.
  o analyzeSGP now passes projcut.digits to studentGrowthProjections to control digits based upon state level configurations.
  o visualizeSGP now checks stateData for grades AND years to be reported in studentGrowthPlots. Default is most recent 5 years
  o studentGrowthPlot accomodates situations where there is a gap between grades (e.g., 8 to 10) and the state calculates 2 year SGPs.
  o Added tag to SGPstateData for earliest year reported to accomodate possibility of reporting only certain years for a state assessment system (e.g., Arizona).
  o ACHIEVEMENT_LEVEL_PRIOR and CATCH_UP_KEEP_UP_STATUS_INITIAL, used for lagged projections, are now calculated as part of analyzeSGP and not combineSGP. This was required in order to allow for growth to standard across holes in grades progression (e.g., 8th to 10th grade).
  o Added addition argument to summarizeSGP (growth_only_summary) that calculates summaries using only student with growth percentiles. This makes bubblePlots better for research investigations (but not as relevant for accountability displays).
  o Added parallel growthAchievementPlot figure production within visualizeSGP.
  o Added population size to goodness of fit plots.
  o Changed Grade to Grade Progression in goodness of fit plots to better identify groups being analyzed.
  o Added median SGP line to Style 100 of bubblePlot_Styles.
  o prepareSGP now accepts data.frame with arguments names.original, names.sgp, names.type, names.info to enhance analyze flow through SGP analyses.
  o Removed doSMP parallel configuration due to removal of doSMP from CRAN.
  o Added 'grade.progression.labels' argument to studentGrowthPercentile to faciliate coefficient matrix storage in Coefficient_Matrix list.
  o prepareSGP now creates knots and boundaries for embedding in SGPstateData and utilizes those quantities in currently executing calculations.
  o Added additional metadata to @Names slot: names.provided, names.sgp, names.type, names.info, names.output.
  o prepareSGP creates @Names meta data.
  o Added sqliteSGP to SGP package and integrated that into the outputSGP functionality.
  o Added additional Mississippi state data to SGPstateData.
  o For studentGrowthPlot production in parallel, jobs are submitted by school size in decreasing order to increase performance.
  o Added analytic median SGP confidence interval calculation to bootstrap confidence interval. Analytic confidence intervals calculated by default for all groups.
  o Added New Hampshire Variable Name Lookup to SGPstateData.
  o Added startParallel and stopParallel to better externalize parallel processing implementation.
  o Made some slight tweaks to capwords to better accomodate all caps situations.
 

  USER VISIBLE CHANGES:

  o Consolodated warning messages to provide better information, especially when working in parallel configurations.
  o Updated Massachusetts grade 10 cutscores between proficient and advanced achievement levels.
  o Lagged projections are only calculated for students with an SGP within analyzeSGP. This eliminates the necessity for the sgp.target.to.NA argument and feature in combineSGP.
  o sgp.target.to.NA feature eliminated from combineSGP for reasons explicated in previous remark.
  o Changed "Phone Number" to "Contact" on studentGrowthPlot and made associated changes of label in SGPstateData.
  o Updated NECAP CSEMs for 2011_2012 in SGPstateData.
  o Added Hawaii baseline coefficient matrices to SGPstateData.
  o Added test to analyzeSGP to see if CSEMs exist in SGPstateData.
  o Added growthAchievementPlot_Styles to better accomodate utilization of growthAchievementPlot in parallel.

  BUG FIXES:

  o studentGrowthPlot in visualizeSGP now filters on GRADES that correspond to VALID_CASE.
  o Fixed issue when projections occur across skipped grades. Made major refinements to analyzeSGP in the process.
  o Updated code to conform with changes in data.table 1.7.8.
  o bPlot.format no case insensitive.
  o Switch installed.packages to find.package to test for pdf2 installation.
  o Modified subsetting of get.panel.data inside studentGrowthPercentiles to avoid data.table seg fault.

Changes in version: SGP_0.8-0.0

  NEW FEATURES:

  o Separated sgpData and sgpData_LONG into new package SGPdata.
  o Changed name of stateData to SGPstateData.
  o Added System_Type slot to stateData to indicate whether state uses 'Cohort Referenced', 'Baseline Referenced', or 'Cohort and Baseline Referenced'. 
  o Added Test_Vendor slot to stateData. 
  o Added California data to stateData. 
  o Added New York baseline coefficient matrices to stateData. 
  o Modified stateData to include "Scale_Change" slot in "Assessment_Program_Information" to indicate content area and year when scale has been changed.  
  o Modified stateData and growthAchievementPlot to accomodate states that change vertical scales from one year to next (e.g., Arizona Mathematics). 
  o Improved parallel implementation of baseline SGP coefficient matrix calculation. 
  o Added ability to accomodate year specific knots and boundaries supplied in stateData. 
  o Added Arizona knots and boundaries to stateData. 
  o Began implementing changes utilizing new pointer features in data.table 1.7.3.
  o Added lag.increment argument to studentGrowthProjections to accomodate state with scale and cutscore changes.
  o Added knots.boundaries.by.panel argument to studentGrowthProjections to accomodate knots and boundaries calculations by panel (instead of pooling grade level data across panels).
  o prepareSGP augments instead of overwrites SGP_Package_Version and Date_Prepared keeping more meta data on the construction of the object.
  o Added function as.splineMatrix to faciliate conversion of older coefficient matrices to S4 class splineMatrix.
  o Added test of is.splineMatrix to prepareSGP and conversion of coefficient matrices to splineMatrix class otherwise.
  o Added max.order.for.percentile argument ot studentGrowthPercentiles to limit number of priors used in analyses (which could already be accomplished by a variety of other means).
  o Added sgp.target.to.NA argument to combineSGP (defaults to TRUE) to change SGP_TARGET and SGP_TARGET_BASELINE to NA when SGP is NA (e.g., for retained students). Thanks for Ayaka Nukui for observation and suggestion.
  o Added sgPlot.baseline arguement to visualizeSGP to control whether cohort or baseline referenced SGPs are depicted in student growth plots.

  USER VISIBLE CHANGES:

  o bubblePlot doesn't load package pdf2 with R version 2.14 or greater until bugs are reconciled with data tips. Use of pdf2 requires R version 2.13.2 or earlier. 
  o analyzeSGP calls to studentGrowthProjections for cohort and lagged projections checks for max.order.for.progression with Scale_Change slot in stateData. This will be required when states switch to either assessment consortium.  
  o Modified growthAchievementPlot call in visualizeSGP to adjust max.order.for.progression based upon previous two changes.  
  o Added argument gaPlot.max.order.for.progression to growthAchievementPlot allowing user to specify maximum order for growthAchievementPlot projection. Useful for states changing scales. 
  o Improved parallel implementation of baseline SGP coefficient matrix calculation. 
  o studentGrowthProjections now checks if current year's data fall within loss.hoss boundaries and corrects if they don't. 
  o Better integrated parallelization routines into analyzeSGP. 
  o Updated analyzeSGP with doSMP to better faciliate parallel analyses in Windows environments. 
  o Continued to optimize studentGrowthPercentiles and studentGrowthProjections functions for better memory mangement and speed. 
  o Created a single baselineSGP function for both use cases previously provided by the baselineSGP and baselineSGPLong functions. 
  o bubblePlot appropriately scales labels provided by argument bubble_plot_data.BUBBLE_CENTER_LABEL. 
  o When knots and boundaries are automatically calculated, only prior scores are used for pooling purposes. Previously both prior and current scores were pooled.
  o Updated Idaho meta data in stateData including knots, boundaries and organizational information.
  o studentGrowthProjections now includes arugment calculate.sgps (default to TRUE) that is used to bypass calculations by analyzeSGP in certain special cases (e.g., scale change in state).
  o Updated Maine metadata to include knots and boundaries.
  o Changed internal naming implementation of SGP_BASELINE in combineSGP.

  BUG FIXES:

  o Refined combineSGP to better accomodate irregular content area and year specifications for both cohort and baseline referenced SGPs. 
  o Corrected bug in bubble_plot_configs.BUBBLE_COLOR where specifying a single color didn't provide the correct color. 
  o studentGrowthProjections now checks for grades in cutscores based upon the supplied subject given in sgp.labels. 
  o Modified sgp.config in analyzeSGP to correctly work with grades supplied as an argument (Thanks to Ayaka Nukui for pointing this out). 
  o Argument grades now correctly passed from abcSGP to analyzeSGP (Thanks to Ayaka Nukui for pointing this out). 
  o Changed incorrect cutscore in state data for advanced level in DEMO data from 509 to 510. 
  o studentGrowthProjections start/stop message now reports correct grade progression when limited number of priors is selected. 

Changes in version: SGP_0.7-2.0

  o prepareSGP now adds an updated Version to an SGP object that is passed to prepareSGP. 
  o In cases where stateData cutscores change by year, studentGrowthProjections correctly chooses annual cutscores to use for projections. 
  o Corrected bug in bubblePlot_Styles that mishandled situation when no ACHIEVEMENT_LEVEL_PRIOR is present. 
  o Updated/correct abcSGP man page. 
  o Refined file naming in bubblePlot_Styles and growthAchievementPlot to change spaces to underscores. 
  o Updated New York cutscores in stateData. 
  o Added Arizona data to stateData. 
  o Added NECAP CSEMs (2010 and 2011) to stateData. 
  o Added Rhode Island Baseline Coefficient Matrices to stateData and added additional Rhode Island data. 
  o Refined abcSGP to not calculate simulated SGPs if missing in stateData for supplied state. 
  o Changed naming of saved baseline coefficient matrix object. 
  o Corrected bug with SCALE_SCOREs and TRANSFORMED_SCALE_SCOREs in growthAchievementPlot. 
  o Modified studentGrowthPercentiles to test for missing years in provided CSEM data. 
  o Refined .mergeSGP in analyzeSGP to increase performance. 
  o Made slight modification to arguments determining whether simulated SGPs will be calculated. 
  o Refined rbind.all in combineSGP to accomodate different annual SGP data calculations (e.g., CSEMs in 2011 but not 2010).
  o Created arguments to analyzeSGP: sgp.percentiles.baseline.max.order, sgp.projections.baseline.max.order and sgp.projections.lagged.baseline.max.order to control baseline SGP order (defaulting to 3).

Changes in version: SGP_0.7-1.0

  o Updated Nevada state data for low, typical, and high cutscores. 
  o Added "Percentile Growth Trajectories" to package title. 
  o Rectified argument passing between abcSGP and analyzeSGP for parallel.config argument. 

Changes in version: SGP_0.7-0.0

  o ETHNICITY and GENDER variables are no longer required to create anonymized (random name) student growth plots. Dummy values are created if missing. 
  o Began outputSGP as a function to faciliate output of SGP results in common formats. 
  o Added robust parallelism to analyzeSGP to better facilitate analysis of large scale data sets on multi-core/multi-cpu environments. 
  o Added functionality to combineSGP to merge in baseline student growth percentiles and baseline student growth percentile targets.
  o Added functionality to analyzeSGP to calculate baseline student growth projections and lagged baseline student growth projections.
  o Fixed a bug preventing use of provided CSEM variable when supplied as an addition variable in the supplied data.frame.
  o Fixed a bug in visualizeSGP for studentGrowthPlot production when sgPlot.years is supplied.
  o Refined scale score axis span and labels in growth achievement plot. 
  o Changed goodness.of.fit default to TRUE with the calculation of baseline student growh percentiles. 
  o Added state test abbreviation to main title of bubble plots. 
  o Refined analyzeSGP and baselineSGP to deal with non-consecutive grades when calculating baseline referenced student growth percentiles. 
  o Added Utah data to stateData. 
  o Fixed naming issue in bubblePlot_Style 2. 
  o Fixed bugs impacting states with non-uniform cutscores by year in bubblePlot_Styles and studentGrowthPlot (Thanks Juan D'Brot). 
  o Fixed a bug preventing users from using their own supplied list of cutscores (Thanks Katherine Castellano). 
  o Added baseline coefficient matrices for Massachusetts to stateData and changed cutscores to match g-theta values used in SGP calculations. 
  o Added baseline coefficient matrices for Nevada to stateData. 
  o Added dummy instructor numbers, weights, and enrollment status to sgpData_LONG. 
  o Changed "Date" slot to "Version" slot in splineMatrix class so that SGP version meta-data was available and consistent with SGP class.
  o Improved goodness of fit color function that avoids errors when empty cells (i.e., color=NA) occur because of badly misfit data.

Changes in version: SGP_0.6-1.0

  o Added check on file name to bubblePlot to remove forward slashes "/".

Changes in version: SGP_0.6-0.0

  o Removed modulo score transformation from stateData as piecewise.transform takes care of this internally.
  o Changed default of summarizeSGP to calculate multi-year summaries across the 3 most recent years instead of all years except the first two.
  o Modified visualizeSGP to better faciliate mass production of studentGrowthPlots with parallel back end.
  o Added studentGrowthPlot_Styles to separate data manipulation from report formatting.
  o Changed default sgPlot.demo.report in visualizeSGP from TRUE to FALSE.
  o Added is.SGP to test for SGP class.
  o Added Version slot to class SGP indicating Version of SGP package used to create SGP object and date object was created.
  o Modified growthAchievementPlot to depict regions showing college/career readiness if cutscores are available in terminal grade of growth and achievement chart.

Changes in version: SGP_0.5-0.0

  o Modified functionality to calculate confidence intervals for SGP. calculate.confidence.intervals argument now accepts state acronym and supplied CSEM variable as part of panel.data.
  o Added Mississippi data to stateData.
  o Refined and corrected minor bug in .get.config in analyzeSGP.
  o Improved sgpPlot.cleanup to avoid removing files unintentionally.
  o Refined parallel implementation in analyzeSGP.


Changes in version: SGP_0.4-6.0

  o Worked out bug in production of studentGrowthPlots for students with completely missing data.
  o Added to and corrected stateData for West Virginia.

Changes in version: SGP_0.4-5.0

  o Added enhanced check to built in knots and boundaries for states.
  o Fixed a bug in studentGrowthProjections when chunk.size is a perfect divisor of the number of rows of the data.
  o Refined studentGrowthPlot to accomodate annual cutscore changes in states with a vertical scale (e.g., West Virginia). Thanks Juan D'Brot WVDOE.

Changes in version: SGP_0.4-0.0

  o Fixed a bug in visualizeSGP that didn't transform projection cuts for the studentGrowthPlot to the transformed scale when necessary.
  o Improved look of two panel student growth plot.
  o Improved header to bubblePlots. Thanks to Dr. Sharon Schattgen (MO) for the suggestion.
  o Added NAMESPACE to package.
  o Modified DESCRIPTION file to accomodate Authors@R requirements.
  o Updated West Virginia stateData.
  o Added Minnesota to stateData.
  o Made slight tweaks to growthAchievementPlot title.
  o Added ability for user to supply CSEMs as a separate variable for SGP confidence interval calculations.
  o Removed eval(eval() calls used for data.table based upon refinements in data.table package.
  o CATCH_UP_KEEP_UP_STATUS is now a factor instead of (wrongly) a character.
  o CATCH_UP_KEEP_UP_STATUS_INITIAL variable is now a factor instead of (wrongly) an ordered factor.
  o studentGrowthPlot and growthAchievementPlot now accommodate the existence of both non-vertical and vertical scales for different content areas in the same state assessment system (e.g., Connecticut).
  o Fixed exact.grade.progression argument to studentGrowthPercentiles. When set to true, function will calculate coefficient matrix and SGPs (if requested) for just that progression.
  o Changed name of Variable_Name_Lookup slot in SGP class to Names.
  o Made minor modifications to growthAchievementPlot to improve the look of growth achievement plots.
  o Made minor modifications to studentGrowthPlot and visualizeSGP to improve the look of student growth plots.
  o Updated student growth projections function to allow for skipped percentiles.
  o Added bubblePlot_Style 10 which shows district schools highlighted against the state.
  o Made minor modifications to the bubblePlot function allowing better highlighting in the presence of hundreds of bubbles.
  o Coefficient matrix objects returned from studentGrowthPercentiles are S4 class splineMatrix with Knots and Boundaries and Date slots.
  o Added wrapper function baselineSGP to facilitate baseline SGP analyses (i.e. multiple cohort norm groups).
  o Added production of baseline referenced coefficient matrices and student growth percentile functionality to analyzeSGP.

Changes in version: SGP_0.3-6.0

  o Updated state data to include New Haven School District specific fields including fixed knots and boundaries.
  o Updated Wisconsin state data to produce growthAchievementPlots and studentGrowthPlots.
  o growthAchievementPlot now filters out grades not in stateData Grades_Reported.
  o Changed argument max.forward.progression to max.forward.progression.years and added argument max.forward.progression.grade.

Changes in version: SGP_0.3-5.0

  o Corrected an offset of 1 in studentGrowthProjections (Thanks for Marie Huchton for finding discrepancies).
  o Improved header in growthAchievementChart.

Changes in version: SGP_0.3-0.0

  o Added an example to studentGrowthPercentiles showing how embedded coefficient matrices can be used to calculate student growth percentiles. 
  o Lots of little bug fixes in visualizeSGP, studentGrowthPlt, bubblePlot, and growthAchievmentPlot, particularly when scale is transformed. 
  o In analyzeSGP, the automatic configuration has been improved to better select grade progressions associated with the provided data. 
  o Began adding functionality to use parallel backends from using different parallelization implementations (SNOW, FOREACH, MULTICORE). 
  o studentGrowthProjections now accomodates year dependent cutscores (in situations where states change cutscores). 
  o piecewise.transform function accomodates year dependent cutscores. This impact both studentGrowthPlots and growthAchievementPlots when scale score transformations are employed to view SGP results.

Changes in version: SGP_0.2-1.0

  o Added functionality to auto-detect state names based upon SGP object name convention: State_Data (e.g. ,Colorado_Data). 
  o Fixed bug allowing users to specify multiple sgp.summaries in summarizeSGP. 
  o Corrected error in achievement level labels in Nevada state data. 

Changes in version: SGP_0.2-0.0

  o prepareSGP returns object of class SGP unaltered and prepares data.frames as before. 
  o abcSGP now passes supplied years and content_areas arguments to combineSGP to allow for year/content area specific merges. This functionality will assist in updating results from year to year. 
  o combineSGP now accepts arguments for years and content_areas allowing for year/content area specific merges. This functionality will assist in updating results from year to year. 
  o Improvement of bubblePlot to better represent situations with hundreds/thousands of bubbles. 
  o Inclusion of growthAchievementPlot that provides plots like that on Betebenner (2009) Educational Measurement: Issues and Practice Article.
  o Modification of visualizeSGP to allow for automatic use of growthAchievementPlot.
  o Added arguments to studentGrowthPercentiles and studentGrowthProjections (print.time.taken) to allow user to turn off time.taken message. Defaults to TRUE.
  o Changed splinefun method for CSEM based confidence interval construction to "natural" due to highly non-monotonic behavior with Wisconsin CSEMs. 
  o Added argument to bubblePlot "bubble_plot_configs.BUBBLE_COLOR_GRADIENT_REVERSE" allowing user to reverse color gradient. Defaults to FALSE.
  o Changed default summaries in abcSGP to include summary calculations involving ACHIEVEMENT_LEVEL_PRIOR (such as prior percent at/above proficient).
  o Implemented bug fix associated with data.table in combineSGP function that simplifies data.table implementation of catch-up/keep-up targets.
  o Supplying a non-traditional/sequential grade.progression argument to studentGrowthPercentiles now removes (unless setting argument drop.nonsequential.grade.progression.variables=FALSE) supplied panel.data columns from "holes" in the supplied grade.progression.

Changes in version: SGP_0.1-0.0

  o Implementation of SGP class. 
  o Specified state specific percentile trajectories for student growth projections and stipulated max.forward.progression of 3 years for these trajectories. 
  o Fixed bugs related to bootstrap calculating confidence intervals for all groups instead of those specified. 
  o Completed reportSGP. 
  o Added New Jersey to stateData. 

Changes in version: SGP_0.0-8.5

  o Changed analyzeSGP so that it calculates plus/minus 1 standard error confidence bands on individual SGPs by default. 
  o Added bootstrap confidence intervals to summarizeSGP. 
  o Added West Virginia to stateData. 
  o Added Nevada knots and boundaries to stateData. 
  o studentGrowthPercentiles can now access CSEM by year from stateData if available. 
  o Consolidated timing messages in studentGrowthPercentiles and studentGrowthProjections at end of function. 

Changes in version: SGP_0.0-8.0

  o Implemented more intelligent error handling for missing arguments in studentGrowthPercentiles and studentGrowthProjections passed from analyzeSGP. 
  o Change default argument for simulate.sgps in analyzeSGP to TRUE. 
  o Added Georgia and Nevada to stateData. 
  o combineSGP now creates CATCH_UP_KEEP_UP_STATUS and CATCH_UP_KEEP_UP_STATUS_INITIAL variables if requesting lagged projections. 
  o Parallelized analyzeSGP using foreach. 
  o Fixed incorrect naming of percentile cuts in studentGrowthProjections function. 
  o Achievement Level in sgpData_LONG is now an ORDERED factor. 
  o Corrected numerous bugs in studentGrowthProjections (Thanks to New Hampshire Department of Education/Deb Wiswell and Tim Kurtz) that led to incorrect catch-up/keep-up results.

Changes in version: SGP_0.0-7.0

  o Changed LICENSE to Creative Commons CC BY-NC-SA 3.0 and CC BY-SA 3.0 for graphics producing and non-graphics producing functions, respectively. 
  o combineSGP now calculates SGP targets based upon catch-up/keep-up to proficient growth-to-standard recommendations. 
  o Cleaned up documentation for analyzeSGP, combineSGP, and summarizeSGP. 
  o Fixed numerous bugs in analyzeSGP, combineSGP, and summarizeSGP. 
  o Added Missouri, New York, Colorado, and Massachusetts CSEMs to stateData. 
  o Added two graphical functions bubblePlot and studentGrowthPlot to the package.  
  o Added fields to sgpData_LONG including IEP_STATUS, DISTRICT_NUMBER, DISTRICT_NAME, SCHOOL_ENROLLMENT_STATUS, DISTRICT_ENROLLMENT_STATUS, STATE_ENROLLMENT_STATUS to better reflect the structure of state data sets.  

Changes in version: SGP_0.0-6.9

  o Added additional argument to studentGrowthPercentiles, growth.levels, allowing user to get a variable indicating the level of growth based upon state or user specified cuts and labels.
  o Changed my.grade argument in sgp.labels to my.extra.label to better reflect nature of argument. This argument is now available in use.my.knots.boundaries and use.my.coefficient.matrices in both the studentGrowthPercentiles and studentGrowthProjections functions.
  o Changed output names of studentGrowthProjections results to better indicate GRADE.
  o Changed compression on stateData file to xz.
  o Changed default values of projection.unit and projcut.digits in studentGrowthProjections to GRADE and 0, respectively.
  o Added wrapper functions prepareSGP, analyzeSGP, combineSGP, and summarizeSGP to facilitate operational SGP analyses.
  o use.my.knots.boundaries with studentGrowthProjections now allows state to be supplied.
  o Added time elapsed to studentGrowthPercentiles and studentGrowthProjections print out.
  o Fixed bugs and updated documentation/examples.
  o Added requirement to data.table depends for version >= 1.5.3.
  o Changed default of percentile.trajectory.values from 1:99 to NULL (which seemed much more sensible).

Changes in version: SGP_0.0-6.8

  o Includes additional dummy data set, sgpData_LONG, to be used in upcoming operational examples.
  o Updated documentation.
  o studentGrowthPercentiles outputs SGPs as integer instead of numeric.
  o studentGrowthProjections outputs SGP cuts as integer instead of numeric.
  o Fixed bug on how studentGrowthPercentiles handles panel.data supplied as a matrix.

Changes in version: SGP_0.0-6.7

  o Added functionality to calculate confidence intervals (calculate.confidence.intervals) of student growth percentiles using CSEMs from state assessment data.  
  o Added argument print.sgp.order to request that the order of the student growth percentile be provided as well as the student growth percentile.  
  o Integrated data.table functionality into studentGrowthPercentiles function to significantly increase speed of some calculations.  
  o Removed INDEX file from package.  
  o studentGrowthPercentiles now converts all input scores to numeric.   
  o Added data to stateData file.  

Changes in version: SGP_0.0-6.6

  o For use.my.knots.and.boundaries user can now supply a two letter state acronym to access embedded, baseline knots and boudaries compiled from work with states.  
  o Fixed goodness of fit printouts so that they show appropriate number of digits.  
  o Fixed DESCRIPTION and eliminated NAMESPACE file.  
  o Added extensive documentation to stateData file and fixed typos.  
  o Updated documentation.  
  o Added date() to finishing message when studentGrowthPercentiles completes an analysis.  
  o Added exact.grade.progression option to studentGrowthPercentiles to accomodate rare situations where one wants the exact grade progression supplied to be run. 

Changes in version: SGP_0.0-6.5

  o Added my.grade to sgp.labels to accomodate situations where my.year and my.subject are not unique. 
  o Fixed bugs associated with use of data.tables.
  o Changed license to GPL-3.
  o Fixed bug associated with argument print.other.gp=TRUE.

Changes in version: SGP_0.0-6.4

  o Fixed bug associated with goodness-of-fit table production when no SGPs are requested.
  o Fixed studentGrowthPercentiles function to work with character grade levels as well as numeric.

Changes in version: SGP_0.0-6.3

  o Fixed issue with argument calculate.sgps in studentGrowthPercentile function.

Changes in version: SGP_0.0-6.2

  o Cleaned up documentation.
  o Corrected data.table bug in studentGrowthProjections.

Changes in version: SGP_0.0-6.1

  o Fixed scoping issue with data.table implementation in studentGrowthProjections.

Changes in version: SGP_0.0-6

  o studentGrowthPercentiles and studentGrowthProjections function now produce a list with results (Knot_Boundaries, Coefficient_Matrices, Goodness_of_Fit, SGPercentiles, SGProjections) embedded.
  o studentGrowthPercentiles and studentGrowthProjections currently accept any number of panels and no longer limited to datasets of at most 8 panels.
  o studentGrowthPercentiles now accepts argument panel.data.vnames allowing user to specify a subset of variables from supplied data for analysis. 
  o studentGrowthPercentiles now accepts argument grade.progression allowing user to specify a not necessarily consecutive grade progression to perform analyses. 
  o studentGrowthPercentiles now accepts argument use.my.coefficient.matrices allowing user to specify pre-calculated coefficient matrices for student growth percentile calculation. 
  o studentGrowthPercentiles now automatically calculates maximum number of priors unless when using the grade.progression argument.
  o studentGrowthPercentiles can calculate student growth percentiles on panel data without any filtering on columns/fields.
  o studentGrowthPercentiles now defaults to providing NO percentile cuts associated with each conditional distribution. The function used to provide 1st, 35th, 65th, and 99th percentile cuts.
  o Knots_Boundaries now also includes a field for loss (lowest obtainable scale score) and hoss (highest obtainable scale score) named "loss.hoss".
  o Boundaries that are automatically calculated by the function now extend 10 percent beyond the range to better accomodate scale extension over time. Previous was 1 percent.
  o studentGrowthPercentiles now accepts boolean argument calculate.sgps controling whether function actually produces student growth percentiles (possibly just stopping after calculating coefficient matrices)
  o studentGrowthPercentiles now accepts argument knot.percentile.cuts allowing user to specify the quantile cuts used for knot calculation. Defaults to c(0.2,0.4,0.6,0.8).
  o studentGrowthPercentiles now accepts argument sgp.quantiles allowing user to specify the quantiles used for studentGrowthPercentile calculations (i.e., not always percentiles)
  o studentGrowthProjections projects out an arbitrary number of grades/years/time periods.
  o studentGrowthProjections no longer accepts argument num.panels, num.prior.scores, max.num.scores and instead uses the arguments grade.progression and max.forward.progressionand tries to internally select maximum order possible for a students percentile.growth projection/trajectory. 
  o studentGrowthProjections now accepts argument performance.level.cutscores that can utilize state assessment cutscores available within the SGP package.
  o studentGrowthProjections now accepts argument projection.unit that allows percentile growth projections/trajectories to be displayed in terms of either GRADE or YEAR.
  o Embedded goodness_of_fit plots are Grid grobs (Grid graphical objects) that can be printed as PDFs (see help for code to produce PDFs of goodness.of.fit plots). 
  o sgpData, the included longitudinal student assessment data file, has been expanded to 5 panels to better illustrate SGP functionality.
  o Includes list stateData to provide state specific information for analyses and reporting. stateData currently includes only performance level cutscores.
  o Updated help file to reflect changes in functions.

Changes in version: SGP_0.0-5

  o Moved CITATION file to inst directory
  o Fixed minor bugs in studentGrowthPercentiles function.

Changes in version: SGP_0.0-4

  o Added LICENSE file including details on the Creative Commons Attribution-Noncommercial-Share Alike 3.0 United State License.
  o Added Goodness-of-fit argument/option/capability to studentGrowthPercentiles function.
  o Incorporated vignette.
  o Cleaned up documentation.
  o Increased percentile growth trajectory/projection to four years from three.
  o Fixed minor bugs in studentGrowthProjections (Thanks to Bob Lee for finding these).

Changes in version: SGP_0.0-3

  o Included option/argument in studentGrowthPercentiles function to avoid quantile crossing based upon Dette & Volgushev (2008)
  o Cleaned up minor errors in documentation.
  o Added optional argument, convert.using.loss.hoss, to studentGrowthPercentiles to convert percentile cuts extended below/above the lowest obtainable scale score/highest obtainable 
    scale score (loss/hoss) to the loss/hoss (defaults to TRUE).

Changes in version: SGP_0.0-2

  o Updated Contributors.
  o Changed rounding of percentile cuts used for growth percentile calculation to 5 decimal places.
  o Changed rounding of automatically produced B-spline knots to 2 decimal places.
  o Extended range of automatically produced B-spline boundaries.
  o Added optional argument, percuts.digits, to studentGrowthPercentiles to allow specification of rounding digits for growth percentile cuts (defaults to 2).
  o Added optional argument, percentile.trajectories, to studentGrowthProjections allowing the function to return 1, 2, and 3 year student percentile trajectories based upon supplied percentile values 
    (defaults to 10th, 35th, 50th, 65th, and 90th). 
  o Added optional argument, projcuts.digits, to studentGrowthProjections to allow specification of rounding digits for percentile trajectory cuts (defaults to 2).

Changes in version: SGP_0.0-1

  o Package Released.
